#! /bin/sh
# Based on script Copyright (C) 1998, 1999 Olaf Hoehmann and Tim Janik

	# usage: listplugins.sh c-sources > $@

for file in `echo $@ | sort -u` ; do
        name="`echo $file | sed 's/.h$//'`"
        _name=`echo $name | sed 's/[^A-Za-z0-9]/_/g'`
        cfile="$name.c"
        hfile="$name.h"
        test -e "$cfile" || {
                echo "$cfile: No such file" >&2
                continue
        }
	test -e "$hfile" && grep -q "PLUGIN NOT WORKING" "$hfile" && continue;
	test -e "$hfile" && grep -q "NOT A PLUGIN" "$hfile" && continue;
	if test -e "$hfile" ; then
		echo "${_name}_la_SOURCES = $cfile $hfile"
	else
		echo "${_name}_la_SOURCES = $cfile"
	fi
	echo "${_name}_la_LDFLAGS = -module"
	echo "${_name}_la_LIBADD =" '$(plugin_libs)'
        test -e "$hfile" && {
            echo "EXTRA_HEADERS         += $hfile"
        }
        last="$name.la"
        plugins="$plugins $last"
done

echo
echo "## autogenerated plugins:"
echo "plugin_LTLIBRARIES += \\"
for p in $plugins ; do
        if test "$p" \!= "$last" ; then
                echo "  $p \\"
        else
                echo "  $p"
        fi
done
echo
echo "## Generated data ends here"




