/*
 * Generated by make-gdamsampleconverter.pl.
 */

#include "gdamsampleconverter.h"
#include <common/gdamsample.h>
static void convert_int16_be_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 2);
}
static void convert_int16_be_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char A = src[0];
		dst[0] = b;
		dst[1] = A;
		src += 2;
		dst += 2;
	}
}
static void convert_int16_be_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		unsigned char b = src[1];
		unsigned char c = 0;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_be_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = src[1];
		unsigned char A = src[0];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_be_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		unsigned char b = src[1];
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_be_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = src[1];
		unsigned char A = src[0];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_be_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		dst[0] = A;
		src += 2;
		dst += 1;
	}
}
static void convert_int16_be_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = src[1];
		dst[0] = a;
		dst[1] = b;
		src += 2;
		dst += 2;
	}
}
static void convert_int16_be_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char a = src[0] ^ 0x80;
		dst[0] = b;
		dst[1] = a;
		src += 2;
		dst += 2;
	}
}
static void convert_int16_be_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = 0;
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_be_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = src[1];
		unsigned char a = src[0] ^ 0x80;
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_be_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_be_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = src[1];
		unsigned char a = src[0] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_be_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		dst[0] = a;
		src += 2;
		dst += 1;
	}
}
static void convert_int16_le_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1];
		unsigned char b = src[0];
		dst[0] = A;
		dst[1] = b;
		src += 2;
		dst += 2;
	}
}
static void convert_int16_le_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 2);
}
static void convert_int16_le_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1];
		unsigned char b = src[0];
		unsigned char c = 0;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_le_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = src[0];
		unsigned char A = src[1];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_le_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1];
		unsigned char b = src[0];
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_le_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = src[0];
		unsigned char A = src[1];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_le_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1];
		dst[0] = A;
		src += 2;
		dst += 1;
	}
}
static void convert_int16_le_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1] ^ 0x80;
		unsigned char b = src[0];
		dst[0] = a;
		dst[1] = b;
		src += 2;
		dst += 2;
	}
}
static void convert_int16_le_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[0];
		unsigned char a = src[1] ^ 0x80;
		dst[0] = b;
		dst[1] = a;
		src += 2;
		dst += 2;
	}
}
static void convert_int16_le_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1] ^ 0x80;
		unsigned char b = src[0];
		unsigned char c = 0;
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_le_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = src[0];
		unsigned char a = src[1] ^ 0x80;
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_le_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1] ^ 0x80;
		unsigned char b = src[0];
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_le_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = src[0];
		unsigned char a = src[1] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src -= 2;
		dst -= 4;
	}
}
static void convert_int16_le_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1] ^ 0x80;
		dst[0] = a;
		src += 2;
		dst += 1;
	}
}
static void convert_int24_be_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1];
		unsigned char b = src[2];
		dst[0] = A;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_int24_be_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[2];
		unsigned char A = src[1];
		dst[0] = b;
		dst[1] = A;
		src += 4;
		dst += 2;
	}
}
static void convert_int24_be_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 4);
}
static void convert_int24_be_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[3];
		unsigned char b = src[2];
		unsigned char A = src[1];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_be_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1];
		unsigned char b = src[2];
		unsigned char c = src[3];
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_be_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = src[3];
		unsigned char b = src[2];
		unsigned char A = src[1];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_be_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1];
		dst[0] = A;
		src += 4;
		dst += 1;
	}
}
static void convert_int24_be_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1] ^ 0x80;
		unsigned char b = src[2];
		dst[0] = a;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_int24_be_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[2];
		unsigned char a = src[1] ^ 0x80;
		dst[0] = b;
		dst[1] = a;
		src += 4;
		dst += 2;
	}
}
static void convert_int24_be_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1] ^ 0x80;
		unsigned char b = src[2];
		unsigned char c = src[3];
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_be_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[3];
		unsigned char b = src[2];
		unsigned char a = src[1] ^ 0x80;
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_be_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1] ^ 0x80;
		unsigned char b = src[2];
		unsigned char c = src[3];
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_be_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = src[3];
		unsigned char b = src[2];
		unsigned char a = src[1] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_be_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1] ^ 0x80;
		dst[0] = a;
		src += 4;
		dst += 1;
	}
}
static void convert_int24_le_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[2];
		unsigned char b = src[1];
		dst[0] = A;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_int24_le_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char A = src[2];
		dst[0] = b;
		dst[1] = A;
		src += 4;
		dst += 2;
	}
}
static void convert_int24_le_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[2];
		unsigned char b = src[1];
		unsigned char c = src[0];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_le_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 4);
}
static void convert_int24_le_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[2];
		unsigned char b = src[1];
		unsigned char c = src[0];
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_le_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = src[0];
		unsigned char b = src[1];
		unsigned char A = src[2];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_le_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[2];
		dst[0] = A;
		src += 4;
		dst += 1;
	}
}
static void convert_int24_le_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[2] ^ 0x80;
		unsigned char b = src[1];
		dst[0] = a;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_int24_le_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char a = src[2] ^ 0x80;
		dst[0] = b;
		dst[1] = a;
		src += 4;
		dst += 2;
	}
}
static void convert_int24_le_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[2] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = src[0];
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_le_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[0];
		unsigned char b = src[1];
		unsigned char a = src[2] ^ 0x80;
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_le_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[2] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = src[0];
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_le_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = src[0];
		unsigned char b = src[1];
		unsigned char a = src[2] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src += 4;
		dst += 4;
	}
}
static void convert_int24_le_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[2] ^ 0x80;
		dst[0] = a;
		src += 4;
		dst += 1;
	}
}
static void convert_int32_be_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		unsigned char b = src[1];
		dst[0] = A;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_int32_be_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char A = src[0];
		dst[0] = b;
		dst[1] = A;
		src += 4;
		dst += 2;
	}
}
static void convert_int32_be_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		unsigned char b = src[1];
		unsigned char c = src[2];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_be_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[2];
		unsigned char b = src[1];
		unsigned char A = src[0];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_be_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 4);
}
static void convert_int32_be_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = src[3];
		unsigned char c = src[2];
		unsigned char b = src[1];
		unsigned char A = src[0];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_be_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		dst[0] = A;
		src += 4;
		dst += 1;
	}
}
static void convert_int32_be_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = src[1];
		dst[0] = a;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_int32_be_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char a = src[0] ^ 0x80;
		dst[0] = b;
		dst[1] = a;
		src += 4;
		dst += 2;
	}
}
static void convert_int32_be_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = src[2];
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_be_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[2];
		unsigned char b = src[1];
		unsigned char a = src[0] ^ 0x80;
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_be_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = src[2];
		unsigned char d = src[3];
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_be_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = src[3];
		unsigned char c = src[2];
		unsigned char b = src[1];
		unsigned char a = src[0] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_be_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		dst[0] = a;
		src += 4;
		dst += 1;
	}
}
static void convert_int32_le_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[3];
		unsigned char b = src[2];
		dst[0] = A;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_int32_le_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[2];
		unsigned char A = src[3];
		dst[0] = b;
		dst[1] = A;
		src += 4;
		dst += 2;
	}
}
static void convert_int32_le_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[3];
		unsigned char b = src[2];
		unsigned char c = src[1];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_le_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[1];
		unsigned char b = src[2];
		unsigned char A = src[3];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_le_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[3];
		unsigned char b = src[2];
		unsigned char c = src[1];
		unsigned char d = src[0];
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_le_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 4);
}
static void convert_int32_le_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[3];
		dst[0] = A;
		src += 4;
		dst += 1;
	}
}
static void convert_int32_le_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[3] ^ 0x80;
		unsigned char b = src[2];
		dst[0] = a;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_int32_le_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[2];
		unsigned char a = src[3] ^ 0x80;
		dst[0] = b;
		dst[1] = a;
		src += 4;
		dst += 2;
	}
}
static void convert_int32_le_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[3] ^ 0x80;
		unsigned char b = src[2];
		unsigned char c = src[1];
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_le_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[1];
		unsigned char b = src[2];
		unsigned char a = src[3] ^ 0x80;
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_le_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[3] ^ 0x80;
		unsigned char b = src[2];
		unsigned char c = src[1];
		unsigned char d = src[0];
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_le_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = src[0];
		unsigned char c = src[1];
		unsigned char b = src[2];
		unsigned char a = src[3] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src += 4;
		dst += 4;
	}
}
static void convert_int32_le_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[3] ^ 0x80;
		dst[0] = a;
		src += 4;
		dst += 1;
	}
}
static void convert_int8_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		unsigned char b = 0;
		dst[0] = A;
		dst[1] = b;
		src -= 1;
		dst -= 2;
	}
}
static void convert_int8_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = 0;
		unsigned char A = src[0];
		dst[0] = b;
		dst[1] = A;
		src -= 1;
		dst -= 2;
	}
}
static void convert_int8_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		unsigned char b = 0;
		unsigned char c = 0;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src -= 1;
		dst -= 4;
	}
}
static void convert_int8_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = 0;
		unsigned char A = src[0];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src -= 1;
		dst -= 4;
	}
}
static void convert_int8_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0];
		unsigned char b = 0;
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 1;
		dst -= 4;
	}
}
static void convert_int8_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = 0;
		unsigned char A = src[0];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src -= 1;
		dst -= 4;
	}
}
static void convert_int8_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 1);
}
static void convert_int8_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = 0;
		dst[0] = a;
		dst[1] = b;
		src -= 1;
		dst -= 2;
	}
}
static void convert_int8_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = 0;
		unsigned char a = src[0] ^ 0x80;
		dst[0] = b;
		dst[1] = a;
		src -= 1;
		dst -= 2;
	}
}
static void convert_int8_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = 0;
		unsigned char c = 0;
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src -= 1;
		dst -= 4;
	}
}
static void convert_int8_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = 0;
		unsigned char a = src[0] ^ 0x80;
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src -= 1;
		dst -= 4;
	}
}
static void convert_int8_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		unsigned char b = 0;
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 1;
		dst -= 4;
	}
}
static void convert_int8_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = 0;
		unsigned char a = src[0] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src -= 1;
		dst -= 4;
	}
}
static void convert_int8_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0] ^ 0x80;
		dst[0] = a;
		src += 1;
		dst += 1;
	}
}
static void convert_uint16_be_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = src[1];
		dst[0] = A;
		dst[1] = b;
		src += 2;
		dst += 2;
	}
}
static void convert_uint16_be_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char A = src[0] ^ 0x80;
		dst[0] = b;
		dst[1] = A;
		src += 2;
		dst += 2;
	}
}
static void convert_uint16_be_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = 0;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_be_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = src[1];
		unsigned char A = src[0] ^ 0x80;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_be_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_be_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = src[1];
		unsigned char A = src[0] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_be_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		dst[0] = A;
		src += 2;
		dst += 1;
	}
}
static void convert_uint16_be_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 2);
}
static void convert_uint16_be_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char a = src[0];
		dst[0] = b;
		dst[1] = a;
		src += 2;
		dst += 2;
	}
}
static void convert_uint16_be_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		unsigned char b = src[1];
		unsigned char c = 0;
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_be_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = src[1];
		unsigned char a = src[0];
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_be_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		unsigned char b = src[1];
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_be_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = src[1];
		unsigned char a = src[0];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_be_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		dst[0] = a;
		src += 2;
		dst += 1;
	}
}
static void convert_uint16_le_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1] ^ 0x80;
		unsigned char b = src[0];
		dst[0] = A;
		dst[1] = b;
		src += 2;
		dst += 2;
	}
}
static void convert_uint16_le_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[0];
		unsigned char A = src[1] ^ 0x80;
		dst[0] = b;
		dst[1] = A;
		src += 2;
		dst += 2;
	}
}
static void convert_uint16_le_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1] ^ 0x80;
		unsigned char b = src[0];
		unsigned char c = 0;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_le_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = src[0];
		unsigned char A = src[1] ^ 0x80;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_le_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1] ^ 0x80;
		unsigned char b = src[0];
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_le_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = src[0];
		unsigned char A = src[1] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_le_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1] ^ 0x80;
		dst[0] = A;
		src += 2;
		dst += 1;
	}
}
static void convert_uint16_le_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1];
		unsigned char b = src[0];
		dst[0] = a;
		dst[1] = b;
		src += 2;
		dst += 2;
	}
}
static void convert_uint16_le_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 2);
}
static void convert_uint16_le_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1];
		unsigned char b = src[0];
		unsigned char c = 0;
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_le_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = src[0];
		unsigned char a = src[1];
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_le_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1];
		unsigned char b = src[0];
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_le_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = src[0];
		unsigned char a = src[1];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src -= 2;
		dst -= 4;
	}
}
static void convert_uint16_le_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1];
		dst[0] = a;
		src += 2;
		dst += 1;
	}
}
static void convert_uint24_be_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1] ^ 0x80;
		unsigned char b = src[2];
		dst[0] = A;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_uint24_be_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[2];
		unsigned char A = src[1] ^ 0x80;
		dst[0] = b;
		dst[1] = A;
		src += 4;
		dst += 2;
	}
}
static void convert_uint24_be_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1] ^ 0x80;
		unsigned char b = src[2];
		unsigned char c = src[3];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_be_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[3];
		unsigned char b = src[2];
		unsigned char A = src[1] ^ 0x80;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_be_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1] ^ 0x80;
		unsigned char b = src[2];
		unsigned char c = src[3];
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_be_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = src[3];
		unsigned char b = src[2];
		unsigned char A = src[1] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_be_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[1] ^ 0x80;
		dst[0] = A;
		src += 4;
		dst += 1;
	}
}
static void convert_uint24_be_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1];
		unsigned char b = src[2];
		dst[0] = a;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_uint24_be_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[2];
		unsigned char a = src[1];
		dst[0] = b;
		dst[1] = a;
		src += 4;
		dst += 2;
	}
}
static void convert_uint24_be_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 4);
}
static void convert_uint24_be_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[3];
		unsigned char b = src[2];
		unsigned char a = src[1];
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_be_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1];
		unsigned char b = src[2];
		unsigned char c = src[3];
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_be_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = src[3];
		unsigned char b = src[2];
		unsigned char a = src[1];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_be_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[1];
		dst[0] = a;
		src += 4;
		dst += 1;
	}
}
static void convert_uint24_le_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[2] ^ 0x80;
		unsigned char b = src[1];
		dst[0] = A;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_uint24_le_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char A = src[2] ^ 0x80;
		dst[0] = b;
		dst[1] = A;
		src += 4;
		dst += 2;
	}
}
static void convert_uint24_le_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[2] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = src[0];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_le_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[0];
		unsigned char b = src[1];
		unsigned char A = src[2] ^ 0x80;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_le_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[2] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = src[0];
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_le_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = src[0];
		unsigned char b = src[1];
		unsigned char A = src[2] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_le_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[2] ^ 0x80;
		dst[0] = A;
		src += 4;
		dst += 1;
	}
}
static void convert_uint24_le_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[2];
		unsigned char b = src[1];
		dst[0] = a;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_uint24_le_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char a = src[2];
		dst[0] = b;
		dst[1] = a;
		src += 4;
		dst += 2;
	}
}
static void convert_uint24_le_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[2];
		unsigned char b = src[1];
		unsigned char c = src[0];
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_le_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 4);
}
static void convert_uint24_le_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[2];
		unsigned char b = src[1];
		unsigned char c = src[0];
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_le_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = src[0];
		unsigned char b = src[1];
		unsigned char a = src[2];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src += 4;
		dst += 4;
	}
}
static void convert_uint24_le_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[2];
		dst[0] = a;
		src += 4;
		dst += 1;
	}
}
static void convert_uint32_be_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = src[1];
		dst[0] = A;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_uint32_be_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char A = src[0] ^ 0x80;
		dst[0] = b;
		dst[1] = A;
		src += 4;
		dst += 2;
	}
}
static void convert_uint32_be_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = src[2];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_be_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[2];
		unsigned char b = src[1];
		unsigned char A = src[0] ^ 0x80;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_be_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = src[1];
		unsigned char c = src[2];
		unsigned char d = src[3];
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_be_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = src[3];
		unsigned char c = src[2];
		unsigned char b = src[1];
		unsigned char A = src[0] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_be_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		dst[0] = A;
		src += 4;
		dst += 1;
	}
}
static void convert_uint32_be_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		unsigned char b = src[1];
		dst[0] = a;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_uint32_be_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[1];
		unsigned char a = src[0];
		dst[0] = b;
		dst[1] = a;
		src += 4;
		dst += 2;
	}
}
static void convert_uint32_be_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		unsigned char b = src[1];
		unsigned char c = src[2];
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_be_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[2];
		unsigned char b = src[1];
		unsigned char a = src[0];
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_be_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 4);
}
static void convert_uint32_be_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = src[3];
		unsigned char c = src[2];
		unsigned char b = src[1];
		unsigned char a = src[0];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_be_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		dst[0] = a;
		src += 4;
		dst += 1;
	}
}
static void convert_uint32_le_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[3] ^ 0x80;
		unsigned char b = src[2];
		dst[0] = A;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_uint32_le_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[2];
		unsigned char A = src[3] ^ 0x80;
		dst[0] = b;
		dst[1] = A;
		src += 4;
		dst += 2;
	}
}
static void convert_uint32_le_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[3] ^ 0x80;
		unsigned char b = src[2];
		unsigned char c = src[1];
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_le_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[1];
		unsigned char b = src[2];
		unsigned char A = src[3] ^ 0x80;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_le_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[3] ^ 0x80;
		unsigned char b = src[2];
		unsigned char c = src[1];
		unsigned char d = src[0];
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_le_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = src[0];
		unsigned char c = src[1];
		unsigned char b = src[2];
		unsigned char A = src[3] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_le_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[3] ^ 0x80;
		dst[0] = A;
		src += 4;
		dst += 1;
	}
}
static void convert_uint32_le_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[3];
		unsigned char b = src[2];
		dst[0] = a;
		dst[1] = b;
		src += 4;
		dst += 2;
	}
}
static void convert_uint32_le_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = src[2];
		unsigned char a = src[3];
		dst[0] = b;
		dst[1] = a;
		src += 4;
		dst += 2;
	}
}
static void convert_uint32_le_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[3];
		unsigned char b = src[2];
		unsigned char c = src[1];
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_le_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = src[1];
		unsigned char b = src[2];
		unsigned char a = src[3];
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_le_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[3];
		unsigned char b = src[2];
		unsigned char c = src[1];
		unsigned char d = src[0];
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src += 4;
		dst += 4;
	}
}
static void convert_uint32_le_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 4);
}
static void convert_uint32_le_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[3];
		dst[0] = a;
		src += 4;
		dst += 1;
	}
}
static void convert_uint8_to_int16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = 0;
		dst[0] = A;
		dst[1] = b;
		src -= 1;
		dst -= 2;
	}
}
static void convert_uint8_to_int16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = 0;
		unsigned char A = src[0] ^ 0x80;
		dst[0] = b;
		dst[1] = A;
		src -= 1;
		dst -= 2;
	}
}
static void convert_uint8_to_int24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = 0;
		unsigned char c = 0;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = S;
		dst[1] = A;
		dst[2] = b;
		dst[3] = c;
		src -= 1;
		dst -= 4;
	}
}
static void convert_uint8_to_int24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = 0;
		unsigned char A = src[0] ^ 0x80;
		unsigned char S = (0x80 & A) ? 0xff : 0x00;
		dst[0] = c;
		dst[1] = b;
		dst[2] = A;
		dst[3] = S;
		src -= 1;
		dst -= 4;
	}
}
static void convert_uint8_to_int32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		unsigned char b = 0;
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = A;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 1;
		dst -= 4;
	}
}
static void convert_uint8_to_int32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = 0;
		unsigned char A = src[0] ^ 0x80;
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = A;
		src -= 1;
		dst -= 4;
	}
}
static void convert_uint8_to_int8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	for (i = 0; i < num_samples; i++) {
		unsigned char A = src[0] ^ 0x80;
		dst[0] = A;
		src += 1;
		dst += 1;
	}
}
static void convert_uint8_to_uint16_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		unsigned char b = 0;
		dst[0] = a;
		dst[1] = b;
		src -= 1;
		dst -= 2;
	}
}
static void convert_uint8_to_uint16_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		unsigned char b = 0;
		unsigned char a = src[0];
		dst[0] = b;
		dst[1] = a;
		src -= 1;
		dst -= 2;
	}
}
static void convert_uint8_to_uint24_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		unsigned char b = 0;
		unsigned char c = 0;
		dst[0] = 0;
		dst[1] = a;
		dst[2] = b;
		dst[3] = c;
		src -= 1;
		dst -= 4;
	}
}
static void convert_uint8_to_uint24_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char c = 0;
		unsigned char b = 0;
		unsigned char a = src[0];
		dst[0] = c;
		dst[1] = b;
		dst[2] = a;
		dst[3] = 0;
		src -= 1;
		dst -= 4;
	}
}
static void convert_uint8_to_uint32_be
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char a = src[0];
		unsigned char b = 0;
		unsigned char c = 0;
		unsigned char d = 0;
		dst[0] = a;
		dst[1] = b;
		dst[2] = c;
		dst[3] = d;
		src -= 1;
		dst -= 4;
	}
}
static void convert_uint8_to_uint32_le
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	const unsigned char* src;
	unsigned char* dst;
	int i;
	src = src_ptr;
	dst = dst_ptr;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		unsigned char d = 0;
		unsigned char c = 0;
		unsigned char b = 0;
		unsigned char a = src[0];
		dst[0] = d;
		dst[1] = c;
		dst[2] = b;
		dst[3] = a;
		src -= 1;
		dst -= 4;
	}
}
static void convert_uint8_to_uint8
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if (dst_ptr == src_ptr)
		return;
	g_memmove(dst_ptr, src_ptr, num_samples * 1);
}

static GdamSampleConverter sample_converters[196] = {
	convert_int16_be_to_int16_be,
	convert_int16_be_to_int16_le,
	convert_int16_be_to_int24_be,
	convert_int16_be_to_int24_le,
	convert_int16_be_to_int32_be,
	convert_int16_be_to_int32_le,
	convert_int16_be_to_int8,
	convert_int16_be_to_uint16_be,
	convert_int16_be_to_uint16_le,
	convert_int16_be_to_uint24_be,
	convert_int16_be_to_uint24_le,
	convert_int16_be_to_uint32_be,
	convert_int16_be_to_uint32_le,
	convert_int16_be_to_uint8,
	convert_int16_le_to_int16_be,
	convert_int16_le_to_int16_le,
	convert_int16_le_to_int24_be,
	convert_int16_le_to_int24_le,
	convert_int16_le_to_int32_be,
	convert_int16_le_to_int32_le,
	convert_int16_le_to_int8,
	convert_int16_le_to_uint16_be,
	convert_int16_le_to_uint16_le,
	convert_int16_le_to_uint24_be,
	convert_int16_le_to_uint24_le,
	convert_int16_le_to_uint32_be,
	convert_int16_le_to_uint32_le,
	convert_int16_le_to_uint8,
	convert_int24_be_to_int16_be,
	convert_int24_be_to_int16_le,
	convert_int24_be_to_int24_be,
	convert_int24_be_to_int24_le,
	convert_int24_be_to_int32_be,
	convert_int24_be_to_int32_le,
	convert_int24_be_to_int8,
	convert_int24_be_to_uint16_be,
	convert_int24_be_to_uint16_le,
	convert_int24_be_to_uint24_be,
	convert_int24_be_to_uint24_le,
	convert_int24_be_to_uint32_be,
	convert_int24_be_to_uint32_le,
	convert_int24_be_to_uint8,
	convert_int24_le_to_int16_be,
	convert_int24_le_to_int16_le,
	convert_int24_le_to_int24_be,
	convert_int24_le_to_int24_le,
	convert_int24_le_to_int32_be,
	convert_int24_le_to_int32_le,
	convert_int24_le_to_int8,
	convert_int24_le_to_uint16_be,
	convert_int24_le_to_uint16_le,
	convert_int24_le_to_uint24_be,
	convert_int24_le_to_uint24_le,
	convert_int24_le_to_uint32_be,
	convert_int24_le_to_uint32_le,
	convert_int24_le_to_uint8,
	convert_int32_be_to_int16_be,
	convert_int32_be_to_int16_le,
	convert_int32_be_to_int24_be,
	convert_int32_be_to_int24_le,
	convert_int32_be_to_int32_be,
	convert_int32_be_to_int32_le,
	convert_int32_be_to_int8,
	convert_int32_be_to_uint16_be,
	convert_int32_be_to_uint16_le,
	convert_int32_be_to_uint24_be,
	convert_int32_be_to_uint24_le,
	convert_int32_be_to_uint32_be,
	convert_int32_be_to_uint32_le,
	convert_int32_be_to_uint8,
	convert_int32_le_to_int16_be,
	convert_int32_le_to_int16_le,
	convert_int32_le_to_int24_be,
	convert_int32_le_to_int24_le,
	convert_int32_le_to_int32_be,
	convert_int32_le_to_int32_le,
	convert_int32_le_to_int8,
	convert_int32_le_to_uint16_be,
	convert_int32_le_to_uint16_le,
	convert_int32_le_to_uint24_be,
	convert_int32_le_to_uint24_le,
	convert_int32_le_to_uint32_be,
	convert_int32_le_to_uint32_le,
	convert_int32_le_to_uint8,
	convert_int8_to_int16_be,
	convert_int8_to_int16_le,
	convert_int8_to_int24_be,
	convert_int8_to_int24_le,
	convert_int8_to_int32_be,
	convert_int8_to_int32_le,
	convert_int8_to_int8,
	convert_int8_to_uint16_be,
	convert_int8_to_uint16_le,
	convert_int8_to_uint24_be,
	convert_int8_to_uint24_le,
	convert_int8_to_uint32_be,
	convert_int8_to_uint32_le,
	convert_int8_to_uint8,
	convert_uint16_be_to_int16_be,
	convert_uint16_be_to_int16_le,
	convert_uint16_be_to_int24_be,
	convert_uint16_be_to_int24_le,
	convert_uint16_be_to_int32_be,
	convert_uint16_be_to_int32_le,
	convert_uint16_be_to_int8,
	convert_uint16_be_to_uint16_be,
	convert_uint16_be_to_uint16_le,
	convert_uint16_be_to_uint24_be,
	convert_uint16_be_to_uint24_le,
	convert_uint16_be_to_uint32_be,
	convert_uint16_be_to_uint32_le,
	convert_uint16_be_to_uint8,
	convert_uint16_le_to_int16_be,
	convert_uint16_le_to_int16_le,
	convert_uint16_le_to_int24_be,
	convert_uint16_le_to_int24_le,
	convert_uint16_le_to_int32_be,
	convert_uint16_le_to_int32_le,
	convert_uint16_le_to_int8,
	convert_uint16_le_to_uint16_be,
	convert_uint16_le_to_uint16_le,
	convert_uint16_le_to_uint24_be,
	convert_uint16_le_to_uint24_le,
	convert_uint16_le_to_uint32_be,
	convert_uint16_le_to_uint32_le,
	convert_uint16_le_to_uint8,
	convert_uint24_be_to_int16_be,
	convert_uint24_be_to_int16_le,
	convert_uint24_be_to_int24_be,
	convert_uint24_be_to_int24_le,
	convert_uint24_be_to_int32_be,
	convert_uint24_be_to_int32_le,
	convert_uint24_be_to_int8,
	convert_uint24_be_to_uint16_be,
	convert_uint24_be_to_uint16_le,
	convert_uint24_be_to_uint24_be,
	convert_uint24_be_to_uint24_le,
	convert_uint24_be_to_uint32_be,
	convert_uint24_be_to_uint32_le,
	convert_uint24_be_to_uint8,
	convert_uint24_le_to_int16_be,
	convert_uint24_le_to_int16_le,
	convert_uint24_le_to_int24_be,
	convert_uint24_le_to_int24_le,
	convert_uint24_le_to_int32_be,
	convert_uint24_le_to_int32_le,
	convert_uint24_le_to_int8,
	convert_uint24_le_to_uint16_be,
	convert_uint24_le_to_uint16_le,
	convert_uint24_le_to_uint24_be,
	convert_uint24_le_to_uint24_le,
	convert_uint24_le_to_uint32_be,
	convert_uint24_le_to_uint32_le,
	convert_uint24_le_to_uint8,
	convert_uint32_be_to_int16_be,
	convert_uint32_be_to_int16_le,
	convert_uint32_be_to_int24_be,
	convert_uint32_be_to_int24_le,
	convert_uint32_be_to_int32_be,
	convert_uint32_be_to_int32_le,
	convert_uint32_be_to_int8,
	convert_uint32_be_to_uint16_be,
	convert_uint32_be_to_uint16_le,
	convert_uint32_be_to_uint24_be,
	convert_uint32_be_to_uint24_le,
	convert_uint32_be_to_uint32_be,
	convert_uint32_be_to_uint32_le,
	convert_uint32_be_to_uint8,
	convert_uint32_le_to_int16_be,
	convert_uint32_le_to_int16_le,
	convert_uint32_le_to_int24_be,
	convert_uint32_le_to_int24_le,
	convert_uint32_le_to_int32_be,
	convert_uint32_le_to_int32_le,
	convert_uint32_le_to_int8,
	convert_uint32_le_to_uint16_be,
	convert_uint32_le_to_uint16_le,
	convert_uint32_le_to_uint24_be,
	convert_uint32_le_to_uint24_le,
	convert_uint32_le_to_uint32_be,
	convert_uint32_le_to_uint32_le,
	convert_uint32_le_to_uint8,
	convert_uint8_to_int16_be,
	convert_uint8_to_int16_le,
	convert_uint8_to_int24_be,
	convert_uint8_to_int24_le,
	convert_uint8_to_int32_be,
	convert_uint8_to_int32_le,
	convert_uint8_to_int8,
	convert_uint8_to_uint16_be,
	convert_uint8_to_uint16_le,
	convert_uint8_to_uint24_be,
	convert_uint8_to_uint24_le,
	convert_uint8_to_uint32_be,
	convert_uint8_to_uint32_le,
	convert_uint8_to_uint8,
};

enum {
	SAMPLE_INDEX_int16_be,
	SAMPLE_INDEX_int16_le,
	SAMPLE_INDEX_int24_be,
	SAMPLE_INDEX_int24_le,
	SAMPLE_INDEX_int32_be,
	SAMPLE_INDEX_int32_le,
	SAMPLE_INDEX_int8,
	SAMPLE_INDEX_uint16_be,
	SAMPLE_INDEX_uint16_le,
	SAMPLE_INDEX_uint24_be,
	SAMPLE_INDEX_uint24_le,
	SAMPLE_INDEX_uint32_be,
	SAMPLE_INDEX_uint32_le,
	SAMPLE_INDEX_uint8,
LAST_SAMPLE_INDEX
};

static inline int get_sample_type_index(int bits_per_sample,
                                        int is_signed,
				        int big_endian)
{
	if (bits_per_sample == 8)
		return is_signed ? SAMPLE_INDEX_int8 : SAMPLE_INDEX_uint8;

	if (bits_per_sample == 16)
		return big_endian
		   ? (is_signed?SAMPLE_INDEX_int16_be:SAMPLE_INDEX_uint16_be)
		   : (is_signed?SAMPLE_INDEX_int16_le:SAMPLE_INDEX_uint16_le);

	if (bits_per_sample == 24)
		return big_endian
		   ? (is_signed?SAMPLE_INDEX_int24_be:SAMPLE_INDEX_uint24_be)
		   : (is_signed?SAMPLE_INDEX_int24_le:SAMPLE_INDEX_uint24_le);

	if (bits_per_sample == 32)
		return big_endian
		   ? (is_signed?SAMPLE_INDEX_int32_be:SAMPLE_INDEX_uint32_be)
		   : (is_signed?SAMPLE_INDEX_int32_le:SAMPLE_INDEX_uint32_le);
	return -1;
}

GdamSampleConverter  gdam_sample_converter_get(int      in_bits_per_samp,
					       gboolean in_signed,
					       gboolean in_big_endian,
                                               int      out_bits_per_samp,
					       gboolean out_signed,
					       gboolean out_big_endian)
{
	int src_type_index, dst_type_index;
	int index;

	src_type_index = get_sample_type_index(in_bits_per_samp,
	                                       in_signed,
	                                       in_big_endian);
	dst_type_index = get_sample_type_index(out_bits_per_samp,
	                                       out_signed,
	                                       out_big_endian);
	
	if (src_type_index < 0 || dst_type_index < 0)
		return NULL;

	index = src_type_index * LAST_SAMPLE_INDEX + dst_type_index;
	return sample_converters[index];
}
static void convert_channels_1_to_1
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if ((char*) dst_ptr != (char*) src_ptr)
		g_memmove(dst_ptr, src_ptr,
			num_samples * 1 * sizeof(GdamSampleValue));
}
static void convert_channels_2_to_1
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		out0 += src[1];
		out0 /= 2;
		dst[0] = out0;
		src += 2;
		dst += 1;
	}
}

static void convert_channels_3_to_1
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		out0 += src[1];
		out0 += src[2];
		out0 /= 3;
		dst[0] = out0;
		src += 3;
		dst += 1;
	}
}

static void convert_channels_4_to_1
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		out0 += src[1];
		out0 += src[2];
		out0 += src[3];
		out0 /= 4;
		dst[0] = out0;
		src += 4;
		dst += 1;
	}
}

static void convert_channels_1_to_2
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 2;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		dst[0] = out0;
		dst[1] = out0;
		src -= 1;
		dst -= 2;
	}
}

static void convert_channels_2_to_2
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if ((char*) dst_ptr != (char*) src_ptr)
		g_memmove(dst_ptr, src_ptr,
			num_samples * 2 * sizeof(GdamSampleValue));
}
static void convert_channels_3_to_2
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		int out1 = src[1];
		out0 += src[2];
		out0 /= 2;
		dst[0] = out0;
		dst[1] = out1;
		src += 3;
		dst += 2;
	}
}

static void convert_channels_4_to_2
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		int out1 = src[1];
		out0 += src[2];
		out1 += src[3];
		out0 /= 2;
		out1 /= 2;
		dst[0] = out0;
		dst[1] = out1;
		src += 4;
		dst += 2;
	}
}

static void convert_channels_1_to_3
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 3;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		dst[0] = out0;
		dst[1] = out0;
		dst[2] = out0;
		src -= 1;
		dst -= 3;
	}
}

static void convert_channels_2_to_3
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 3;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		int out1 = src[1];
		dst[0] = out0;
		dst[1] = out1;
		dst[2] = out0;
		src -= 2;
		dst -= 3;
	}
}

static void convert_channels_3_to_3
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if ((char*) dst_ptr != (char*) src_ptr)
		g_memmove(dst_ptr, src_ptr,
			num_samples * 3 * sizeof(GdamSampleValue));
}
static void convert_channels_4_to_3
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		int out1 = src[1];
		int out2 = src[2];
		out0 += src[3];
		out0 /= 2;
		dst[0] = out0;
		dst[1] = out1;
		dst[2] = out2;
		src += 4;
		dst += 3;
	}
}

static void convert_channels_1_to_4
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	src += (num_samples - 1) * 1;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		dst[0] = out0;
		dst[1] = out0;
		dst[2] = out0;
		dst[3] = out0;
		src -= 1;
		dst -= 4;
	}
}

static void convert_channels_2_to_4
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	src += (num_samples - 1) * 2;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		int out1 = src[1];
		dst[0] = out0;
		dst[1] = out1;
		dst[2] = out0;
		dst[3] = out1;
		src -= 2;
		dst -= 4;
	}
}

static void convert_channels_3_to_4
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	GdamSampleValue* src = (GdamSampleValue*) src_ptr;
	GdamSampleValue* dst = (GdamSampleValue*) dst_ptr;
	int i;
	src += (num_samples - 1) * 3;
	dst += (num_samples - 1) * 4;
	for (i = 0; i < num_samples; i++) {
		int out0 = src[0];
		int out1 = src[1];
		int out2 = src[2];
		dst[0] = out0;
		dst[1] = out1;
		dst[2] = out2;
		dst[3] = out0;
		src -= 3;
		dst -= 4;
	}
}

static void convert_channels_4_to_4
                        (void*       dst_ptr,
                         const void* src_ptr,
                         int         num_samples)
{
	if ((char*) dst_ptr != (char*) src_ptr)
		g_memmove(dst_ptr, src_ptr,
			num_samples * 4 * sizeof(GdamSampleValue));
}
static GdamSampleConverter channel_converters[] = {
	convert_channels_1_to_1,
	convert_channels_1_to_2,
	convert_channels_1_to_3,
	convert_channels_1_to_4,
	convert_channels_2_to_1,
	convert_channels_2_to_2,
	convert_channels_2_to_3,
	convert_channels_2_to_4,
	convert_channels_3_to_1,
	convert_channels_3_to_2,
	convert_channels_3_to_3,
	convert_channels_3_to_4,
	convert_channels_4_to_1,
	convert_channels_4_to_2,
	convert_channels_4_to_3,
	convert_channels_4_to_4,
};

GdamSampleConverter  gdam_sample_converter_get_channel_changer
                                              (int      num_channels_in,
					       int      num_channels_out)
{
	int src_type_index, dst_type_index;
	int index;

	if (num_channels_in < 1 || num_channels_in > 4)
		return NULL;
	if (num_channels_out < 1 || num_channels_out > 4)
		return NULL;

	src_type_index = num_channels_in - 1;
	dst_type_index = num_channels_out - 1;
	
	index = src_type_index * 4 + dst_type_index;
	return channel_converters[index];
}
