/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __MODEL_FILTER_PHASER_H_
#define __MODEL_FILTER_PHASER_H_

#include <client/gdamchannel.h>
#include <component/gdamfilter.h>

typedef struct _GdamPhaser GdamPhaser;
typedef struct _GdamPhaserClass GdamPhaserClass;

GtkType gdam_phaser_get_type();
#define GDAM_TYPE_PHASER			(gdam_phaser_get_type ())
#define GDAM_PHASER(obj)			(GTK_CHECK_CAST ((obj), GDAM_TYPE_PHASER, GdamPhaser))
#define GDAM_PHASER_CLASS(klass)		(GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_PHASER, GdamPhaserClass))
#define GDAM_IS_PHASER(obj)		(GTK_CHECK_TYPE ((obj), GDAM_TYPE_PHASER))
#define GDAM_IS_PHASER_CLASS(klass)	(GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_PHASER))

struct _GdamPhaserClass {
	GdamFilterClass		filter_class;
};

struct _GdamPhaser {
	GdamFilter		filter;
	guint 			phaser_id;
    	gfloat 			min_hertz;
    	gfloat 			max_hertz;
    	gfloat 			lfo_hertz;
    	gfloat 			feedback;
    	gfloat 			depth;
};

#endif
