/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_PRODUCER_MICROPHONE_H_
#define __GDAM_PRODUCER_MICROPHONE_H_

#include <component/gdamproducer.h>

typedef struct _GdamProducerMicrophone GdamProducerMicrophone;
typedef struct _GdamProducerMicrophoneClass GdamProducerMicrophoneClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_producer_microphone_get_type();
#define GDAM_TYPE_PRODUCER_MICROPHONE			(gdam_producer_microphone_get_type ())
#define GDAM_PRODUCER_MICROPHONE(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_PRODUCER_MICROPHONE, GdamProducerMicrophone))
#define GDAM_PRODUCER_MICROPHONE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_PRODUCER_MICROPHONE, GdamProducerMicrophoneClass))
#define GDAM_IS_PRODUCER_MICROPHONE(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_PRODUCER_MICROPHONE))
#define GDAM_IS_PRODUCER_MICROPHONE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_PRODUCER_MICROPHONE))

struct _GdamProducerMicrophoneClass {
	GdamProducerClass		producer_microphone_class;
	void     (*set_buffer_id)      (GdamProducerMicrophone*   microphone,
	                                int          	    	 buffer_id);
	void     (*rate_changed)       (GdamProducerMicrophone*   microphone);
};

struct _GdamProducerMicrophone {
	GdamProducer			producer_microphone;

	char*				device_name;
};


void gdam_producer_microphone_set_buffer_id(GdamProducerMicrophone* microphone,
                                           int                    buffer_id);
void gdam_producer_microphone_set_frequency(GdamProducerMicrophone* microphone,
                                           gdouble                hertz);
void gdam_producer_microphone_set_rate     (GdamProducerMicrophone* microphone,
                                           gdouble                rate);


void gdam_producer_microphone_frequency_changed(GdamProducerMicrophone*);
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif

