/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SPATIAL_STEREO_H_
#define __GDAM_SPATIAL_STEREO_H_


typedef struct _GdamSpatialStereo GdamSpatialStereo;
typedef struct _GdamSpatialStereoClass GdamSpatialStereoClass;
#include <component/gdamfilter.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_spatial_stereo_get_type();
#define GDAM_TYPE_SPATIAL_STEREO			(gdam_spatial_stereo_get_type ())
#define GDAM_SPATIAL_STEREO(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SPATIAL_STEREO, GdamSpatialStereo))
#define GDAM_SPATIAL_STEREO_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SPATIAL_STEREO, GdamSpatialStereoClass))
#define GDAM_IS_SPATIAL_STEREO(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SPATIAL_STEREO))
#define GDAM_IS_SPATIAL_STEREO_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SPATIAL_STEREO))

struct _GdamSpatialStereoClass {
	GdamFilterClass			spatial_stereo_class;
	void                          (*positions_change) (GdamSpatialStereo*);
	void                          (*set_speed_of_sound)(GdamSpatialStereo*,
	                                                    gdouble speed);
	void                          (*set_unit_gain_distance)
	                                                   (GdamSpatialStereo*,
	                                                    gdouble distance);
};
struct _GdamSpatialStereo {
	GdamFilter			spatial_stereo;

	gdouble				left_channel_pos[3];
	gdouble				right_channel_pos[3];
	gdouble				left_ear_pos[3];
	gdouble				right_ear_pos[3];

	gdouble				speed_of_sound;
	gdouble				unit_gain_distance;
};

void gdam_spatial_stereo_positions_change       (GdamSpatialStereo* spatial);
void gdam_spatial_stereo_set_speed_of_sound     (GdamSpatialStereo* spatial,
	                                         gdouble            speed);
void gdam_spatial_stereo_set_unit_gain_distance (GdamSpatialStereo* spatial,
	                                         gdouble            distance);


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
