#include "gdamauthmaker.h"

GdamAuthenticator* gdam_auth_maker_make   (GdamAuthMaker* auth_maker)
{
  g_return_val_if_fail (auth_maker != NULL, NULL);
  g_return_val_if_fail (auth_maker->make != NULL, NULL);
  return (*auth_maker->make) (auth_maker);
}

void               gdam_auth_maker_destroy(GdamAuthMaker* auth_maker)
{
  g_return_if_fail (auth_maker != NULL);
  if (auth_maker->destroy != NULL)
    (*auth_maker->destroy) (auth_maker);
}

GdamAuthMaker*     gdam_auth_maker_root_new()
{
  GdamAuthMaker *auth_maker = g_new (GdamAuthMaker, 1);
  auth_maker->make
    = (GdamAuthenticator * (*)(GdamAuthMaker *)) gdam_authenticator_root;
  auth_maker->destroy = (void (*)(GdamAuthMaker *)) g_free;
}
