/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_NAMESPACE_H_
#define __GDAM_NAMESPACE_H_

#include <glib.h>
#include "gdassource.h"
#include "gdamsink.h"

gboolean     gdam_namespace_int_lookup        (const char* our_namespace,
                                               const char* name,
				               int*        rv);
void         gdam_namespace_int_set           (const char* our_namespace,
                                               const char* name,
				               int         val);


#if 0
/* Call before and after servicing a client request. */
void         gdam_namespace_local_clean       ();

/*
 * Get a reference that'll automatically be unref'd when
 * gdam_namespace_local_clean is called.
 * 
 * Used by GDAS_SOURCE_BY_ID.
 */

GdasSource*  gdam_namespace_local_source      (int         source_id);
GdamSink*    gdam_namespace_local_sink        (int         sink_id);


/*
 * Register a return value so it can be accessed as a local source.
 */
int          gdam_namespace_alloc_local_source(GdasSource* source);
int          gdam_namespace_alloc_local_sink  (GdamSink*   sink);
#endif
#endif
