/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SERVER_OBJECT_H_
#define __GDAM_SERVER_OBJECT_H_


typedef struct _GdamServerObject GdamServerObject;
typedef struct _GdamServerObjectClass GdamServerObjectClass;

#include "gdamconnection.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_server_object_get_type();
#define GDAM_TYPE_SERVER_OBJECT			(gdam_server_object_get_type ())
#define GDAM_SERVER_OBJECT(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SERVER_OBJECT, GdamServerObject))
#define GDAM_SERVER_OBJECT_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SERVER_OBJECT, GdamServerObjectClass))
#define GDAM_IS_SERVER_OBJECT(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SERVER_OBJECT))
#define GDAM_IS_SERVER_OBJECT_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SERVER_OBJECT))

struct _GdamServerObjectClass {
	GtkObjectClass		object_class;
};
struct _GdamServerObject {
	GtkObject			object;

	GdamConnection*			connection;
	int				local_id;
	int				global_id;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
