/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_WAV_H_
#define __GDAS_WAV_H_

typedef struct _GdasWav GdasWav;

#include "gdasrawfile.h"

GtkType gdas_wav_get_type();
#define GDAS_TYPE_WAV              (gdas_wav_get_type ())
#define GDAS_WAV(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_WAV, GdasWav))

struct _GdasWav {
	GdamRawFile raw_file;
	char*       filename;
};

gboolean gdas_wav_load(GdasWav* wav, const char* filename);

#endif
