/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_GATE_H_
#define __GDAS_GATE_H_


typedef struct _GdasGate GdasGate;
typedef struct _GdasGateClass GdasGateClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "gdasdynamicrange.h"

GtkType gdas_gate_get_type();
#define GDAS_TYPE_GATE			(gdas_gate_get_type ())
#define GDAS_GATE(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_GATE, GdasGate))
#define GDAS_GATE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_GATE, GdasGateClass))
#define GDAM_IS_GATE(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_GATE))
#define GDAM_IS_GATE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_GATE))

struct _GdasGateClass {
	GdasDynamicRangeClass	dynamic_range_class;
};
struct _GdasGate {
	GdasDynamicRange	dynamic_range;

	GdamSampleValue		threshold;

	/* Pass only quiet noise through. */
	gboolean		inverted;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
