/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAS_MICROPHONE_H_
#define __GDAS_MICROPHONE_H_


typedef struct _GdasMicrophone GdasMicrophone;
typedef struct _GdasMicrophoneClass GdasMicrophoneClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasexternal.h"

GtkType gdas_microphone_get_type();
#define GDAS_TYPE_MICROPHONE			(gdas_microphone_get_type ())
#define GDAS_MICROPHONE(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_MICROPHONE, GdasMicrophone))
#define GDAS_MICROPHONE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_MICROPHONE, GdasMicrophoneClass))
#define GDAM_IS_MICROPHONE(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_MICROPHONE))
#define GDAM_IS_MICROPHONE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_MICROPHONE))

struct _GdasMicrophoneClass {
	GdasExternalClass		external_class;
};
struct _GdasMicrophone {
	GdasExternal			external;
	char*				device_name;
	gboolean			use_helper;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
