/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/


#ifndef __GDAS_PHASER_H
#define __GDAS_PHASER_H

typedef struct _GdasPhaser GdasPhaser;
typedef struct _GdasPhaserClass GdasPhaserClass;

#include <server/gdasfilter.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdas_phaser_get_type();
#define GDAS_TYPE_PHASER			(gdas_phaser_get_type ())
#define GDAS_PHASER(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_PHASER, GdasPhaser))
#define GDAS_PHASER_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_PHASER, GdasPhaserClass))
#define GDAM_IS_PHASER(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_PHASER))
#define GDAM_IS_PHASER_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_PHASER))

struct _GdasPhaserClass {
	GdasFilterClass		filter_class;
};

struct _GdasPhaser {
	GdasFilter 	filter;

	/* parameters. */
	GdamFixed	feedback;
	GdamFixed	depth;

	/* allpass coefficient */
	GdamSampleValue	a;

	/* sample of data in the allpass filter. */
	GdamSample	allpass[6];

	/* final sample. */
	GdamSample	zm1;

	gfloat		min_delay;
	gfloat		max_delay;

	gfloat		lfo_phase;
	gfloat		lfo_incr;
};

#endif
