#ifndef __GDAS_RECORDER_EXTERNAL_H_
#define __GDAS_RECORDER_EXTERNAL_H_


typedef struct _GdasRecorderExternal GdasRecorderExternal;
typedef struct _GdasRecorderExternalClass GdasRecorderExternalClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdasfilter.h"
#include <common/gdamsampleconverter.h>

GtkType gdas_recorder_external_get_type();
#define GDAS_TYPE_RECORDER_EXTERNAL			(gdas_recorder_external_get_type ())
#define GDAS_RECORDER_EXTERNAL(obj)              (GTK_CHECK_CAST ((obj), GDAS_TYPE_RECORDER_EXTERNAL, GdasRecorderExternal))
#define GDAS_RECORDER_EXTERNAL_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAS_TYPE_RECORDER_EXTERNAL, GdasRecorderExternalClass))
#define GDAM_IS_RECORDER_EXTERNAL(obj)           (GTK_CHECK_TYPE ((obj), GDAS_TYPE_RECORDER_EXTERNAL))
#define GDAM_IS_RECORDER_EXTERNAL_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAS_TYPE_RECORDER_EXTERNAL))


struct _GdasRecorderExternalClass {
	GdasFilterClass		filter_class;
};
struct _GdasRecorderExternal {
	GdasFilter		filter;

	GSList*			recorders;
	gboolean		paused;
	guint			last_output_id;

	/* output format information.
	 * currently we always output
	 * native endian, 16-bit, signed, stereo samples.  */
	/* this hack lives within gdas_recorder_external_init. */
	int			sample_size;
	int			num_channels;
	GdamSampleConverter	channel_converter;
	GdamSampleConverter	sample_converter;
};

guint gdas_recorder_external_add_fd     (GdasRecorderExternal* recorder,
                                         int                   fd,
					 int                   buffer_size,
					 int                   pid);
guint gdas_recorder_external_run_command(GdasRecorderExternal* recorder,
                                         const char* const*    command,
					 int                   buffer_size);
void  gdas_recorder_external_set_pause  (GdasRecorderExternal* recorder,
                                         guint                 sink_id,
					 gboolean              pause);
void  gdas_recorder_external_kill_sink  (GdasRecorderExternal* recorder,
                                         guint                 sink_id);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
