/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#include "gdambounceskin.h"
#include <component/gdambounce.h>
#include <component/gdamutil.h>
#include <glade/glade.h>
#include "gdamskin.h"
#include "gdamskinutil.h"


static void gdam_bounce_skin_class_init(GdamBounceSkinClass* klass);
/*    ____ _                 ____  _          __  __ 
 *   / ___| | __ _ ___ ___  / ___|| |_ _   _ / _|/ _|
 *  | |   | |/ _` / __/ __| \___ \| __| | | | |_| |_ 
 *  | |___| | (_| \__ \__ \  ___) | |_| |_| |  _|  _|
 *   \____|_|\__,_|___/___/ |____/ \__|\__,_|_| |_|  
 */                                                 


static void gdam_bounce_skin_init(GdamBounceSkin* skin)
{
}

GtkType gdam_bounce_skin_get_type()
{
  static GtkType bounceskin_type = 0;
  if (!bounceskin_type)
    {
      static const GtkTypeInfo bounceskin_info = {
	"GdamBounceSkin",
	sizeof (GdamBounceSkin),
	sizeof (GdamBounceSkinClass),
	(GtkClassInitFunc) gdam_bounce_skin_class_init,
	(GtkObjectInitFunc) gdam_bounce_skin_init,
	/* reserved_1 */ NULL,
	/* reserved_2 */ NULL,
	(GtkClassInitFunc) NULL
      };
      bounceskin_type = gtk_type_unique (GDAM_TYPE_SKIN, &bounceskin_info);
    }
  return bounceskin_type;
}

/* 
 *  ____  _    _         _____                 _   _                 
 * / ___|| | _(_)_ __   |  ___|   _ _ __   ___| |_(_) ___  _ __  ___ 
 * \___ \| |/ / | '_ \  | |_ | | | | '_ \ / __| __| |/ _ \| '_ \/ __|
 *  ___) |   <| | | | | |  _|| |_| | | | | (__| |_| | (_) | | | \__ \
 * |____/|_|\_\_|_| |_| |_|   \__,_|_| |_|\___|\__|_|\___/|_| |_|___/
 */



static void gdam_bounce_skin_class_init(GdamBounceSkinClass* klass)
{
  GdamSkinClass *skin_class = GDAM_SKIN_CLASS (klass);
  skin_class->model_type = GDAM_TYPE_BOUNCE;
}
