/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAMBOUNCESKIN__H_
#define __GDAMBOUNCESKIN__H_

#include "gdamskin.h"
#include <component/gdambounce.h>


typedef struct _GdamBounceSkinClass GdamBounceSkinClass;
typedef struct _GdamBounceSkin GdamBounceSkin;


GtkType gdam_bounceskin_get_type();
#define GDAM_TYPE_BOUNCESKIN              (gdam_bounceskin_get_type ())
#define GDAM_BOUNCESKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_BOUNCESKIN, GdamBounceSkin))
#define GDAM_BOUNCESKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_BOUNCESKIN, GdamBounceSkinClass))
#define GDAM_IS_BOUNCESKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_BOUNCESKIN))
#define GDAM_IS_BOUNCESKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_BOUNCESKIN))

struct _GdamBounceSkinClass {
	GdamSkinClass		skin_class;
};


struct _GdamBounceSkin {
	GdamSkin		base;
};

typedef struct _NudgeInfo {
	GdamBounce* 		bounce;
	float			amount;
} NudgeInfo;


#endif
