/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
/*
 * A widget which lets the user select from the
 * available buffers.
 *
 * Basically, an inline replacement for buffer manager.
 */
#ifndef __GDAM_BUFFER_COMBO_H_
#define __GDAM_BUFFER_COMBO_H_


typedef struct _GdamBufferCombo GdamBufferCombo;
typedef struct _GdamBufferComboClass GdamBufferComboClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <component/gdambuffermanager.h>
#include <gtk/gtkcombo.h>

GtkType gdam_buffer_combo_get_type();
#define GDAM_TYPE_BUFFER_COMBO			(gdam_buffer_combo_get_type ())
#define GDAM_BUFFER_COMBO(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_BUFFER_COMBO, GdamBufferCombo))
#define GDAM_BUFFER_COMBO_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_BUFFER_COMBO, GdamBufferComboClass))
#define GDAM_IS_BUFFER_COMBO(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_BUFFER_COMBO))
#define GDAM_IS_BUFFER_COMBO_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_BUFFER_COMBO))

struct _GdamBufferComboClass {
	GtkComboClass		combo_class;
	void                  (*buffer_selected)(GdamBufferCombo*  combo,
	                                         int               buffer_id);
};
struct _GdamBufferCombo {
	GtkCombo			combo;

	GList*			new_items;
	GList*			old_items;
	GHashTable*		item_map;
	int			freeze_count;
	GdamBufferManagerNotifier* notifier;
};

GdamBufferCombo* gdam_buffer_combo_new();

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
