/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAMPRODUCERMP3SKIN__H_
#define __GDAMPRODUCERMP3SKIN__H_

#include "gdamskin.h"
#include <component/gdamproducermp3.h>


typedef struct _GdamProducerMp3SkinClass GdamProducerMp3SkinClass;
typedef struct _GdamProducerMp3Skin GdamProducerMp3Skin;


GtkType gdam_producer_mp3_skin_get_type();
#define GDAM_TYPE_PRODUCERMP3SKIN              (gdam_producer_mp3_skin_get_type ())
#define GDAM_PRODUCERMP3SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_PRODUCERMP3SKIN, GdamProducerMp3Skin))
#define GDAM_PRODUCERMP3SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_PRODUCERMP3SKIN, GdamProducerMp3SkinClass))
#define GDAM_IS_PRODUCERMP3SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_PRODUCERMP3SKIN))
#define GDAM_IS_PRODUCERMP3SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_PRODUCERMP3SKIN))

struct _GdamProducerMp3SkinClass {
	GdamSkinClass		skin_class;
};


struct _GdamProducerMp3Skin {
	GdamSkin		base;
};

typedef struct _NudgeInfo {
	GdamProducerMp3* 		producermp3;
	float			amount;
} NudgeInfo;

void gdam_producer_mp3_connect_func(const gchar*   handler,
                                    GtkObject*     object,
                                    const gchar*   signal_name,
                                    const gchar*   signal_data,
                                    GtkObject*     connect_object,
                                    gboolean       after, 
                                    gpointer 	  data);


#endif
