/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAMRESPEED_SKIN__H_
#define __GDAMRESPEED_SKIN__H_

#include "gdamskin.h"
#include <component/gdamrespeed.h>


typedef struct _GdamRespeedSkinClass GdamRespeedSkinClass;
typedef struct _GdamRespeedSkin GdamRespeedSkin;


GtkType gdam_respeed_skin_get_type();
#define GDAM_TYPE_RESPEED_SKIN              (gdam_respeed_skin_get_type ())
#define GDAM_RESPEED_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_RESPEED_SKIN, GdamRespeedSkin))
#define GDAM_RESPEED_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_RESPEED_SKIN, GdamRespeedSkinClass))
#define GDAM_IS_RESPEED_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_RESPEED_SKIN))
#define GDAM_IS_RESPEED_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_RESPEED_SKIN))

struct _GdamRespeedSkinClass {
	GdamSkinClass		skin_class;
};


struct _GdamRespeedSkin {
	GdamSkin		base;
	GtkContainer*           child_container;
	GdamSkin*		child_skin;
};

#endif
