/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#include "gdambalanceskin.h"
#include "../gdamskinutil.h"
#include <common/gdamsample.h>
#include <glade/glade.h>
#include <gtk/gtksignal.h>
#include <stdlib.h>
#include <common/gdamplugin.h>

static void gdam_balance_skin_class_init(GdamBalanceSkinClass* klass);

static void gdam_balance_skin_init(GdamBalanceSkin* skin)
{
}

GtkType gdam_balance_skin_get_type()
{
  static GtkType balance_skin_type = 0;
  if (!balance_skin_type)
    {
      static const GtkTypeInfo balance_skin_info = {
	"GdamBalanceSkin",
	sizeof (GdamBalanceSkin),
	sizeof (GdamBalanceSkinClass),
	(GtkClassInitFunc) gdam_balance_skin_class_init,
	(GtkObjectInitFunc) gdam_balance_skin_init,
	/* reserved_1 */ NULL,
	/* reserved_2 */ NULL,
	(GtkClassInitFunc) NULL
      };
      balance_skin_type = gtk_type_unique (GDAM_TYPE_SKIN,
					   &balance_skin_info);
      gdam_plugin_check_version (__FILE__, GDAM_VERSION);
    }
  return balance_skin_type;
}


static void gdam_balance_skin_class_init(GdamBalanceSkinClass* klass)
{
  GdamSkinClass *skin_class = GDAM_SKIN_CLASS (klass);
  skin_class->model_type = GDAM_TYPE_BALANCE;
}

