/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#include "gdamfilterwavetableskin.h"
#include "../../component/plugins/gdamfilterwavetable.h"
#include <component/gdambuffermanager.h>
#include "../gdamskinutil.h"
#include <common/gdamplugin.h>

static void gdam_filter_wavetable_skin_init(GdamFilterWavetableSkin* filter_wavetable_skin)
{
}
static void gdam_filter_wavetable_skin_class_init(GdamSkinClass* skin_class)
{
}

GtkType gdam_filter_wavetable_skin_get_type()
{
  static GtkType filter_wavetable_skin_type = 0;
  if (!filter_wavetable_skin_type)
    {
      static const GtkTypeInfo filter_wavetable_skin_info = {
	"GdamFilterWavetableSkin",
	sizeof (GdamFilterWavetableSkin),
	sizeof (GdamFilterWavetableSkinClass),
	(GtkClassInitFunc) gdam_filter_wavetable_skin_class_init,
	(GtkObjectInitFunc) gdam_filter_wavetable_skin_init,
	/* reserved_1 */ NULL,
	/* reserved_2 */ NULL,
	(GtkClassInitFunc) NULL
      };
      GtkType parent = GDAM_TYPE_SKIN;
      filter_wavetable_skin_type = gtk_type_unique (parent,
						    &filter_wavetable_skin_info);
      gdam_plugin_check_version (__FILE__, GDAM_VERSION);
    }
  return filter_wavetable_skin_type;
}
