#ifndef __GDAM_SONG_DATABASE_MAKER_SKIN_H_
#define __GDAM_SONG_DATABASE_MAKER_SKIN_H_


typedef struct _GdamSongDatabaseMakerSkin GdamSongDatabaseMakerSkin;
typedef struct _GdamSongDatabaseMakerSkinClass GdamSongDatabaseMakerSkinClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "../gdamskin.h"
#include <gtk/gtkentry.h>

GtkType gdam_song_database_maker_skin_get_type();
#define GDAM_TYPE_SONG_DATABASE_MAKER_SKIN			(gdam_song_database_maker_skin_get_type ())
#define GDAM_SONG_DATABASE_MAKER_SKIN(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SONG_DATABASE_MAKER_SKIN, GdamSongDatabaseMakerSkin))
#define GDAM_SONG_DATABASE_MAKER_SKIN_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SONG_DATABASE_MAKER_SKIN, GdamSongDatabaseMakerSkinClass))
#define GDAM_IS_SONG_DATABASE_MAKER_SKIN(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SONG_DATABASE_MAKER_SKIN))
#define GDAM_IS_SONG_DATABASE_MAKER_SKIN_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SONG_DATABASE_MAKER_SKIN))

struct _GdamSongDatabaseMakerSkinClass {
	GdamSkinClass		skin_class;
};
struct _GdamSongDatabaseMakerSkin {
	GdamSkin		skin;

	GHashTable*		pid_table;

	guint			pending_thread;
	GSList*			first_pending_file;
	GSList*			last_pending_file;

	GtkEntry*		find_starting_path;
	GtkEntry*		find_name_or_regex;
	unsigned                find_traverse_symlinks : 1,
				find_traverse_mount_points : 1,
				find_inverted : 1,
				find_is_name : 1;

	GtkEntry*		locate_entry;

	GtkEntry*		arbitrary_entry;
};

void  gdam_song_database_maker_add_song
                              (GdamSongDatabaseMakerSkin* skin,
			       const char*                filename);

guint gdam_song_database_maker_run_command
                              (GdamSongDatabaseMakerSkin* skin,
                               char**                     command,
			       gboolean                   make_update_window,
			       char                       separator);

guint gdam_song_database_maker_run_find
                              (GdamSongDatabaseMakerSkin* skin);
guint gdam_song_database_maker_run_locate
                              (GdamSongDatabaseMakerSkin* skin);
guint gdam_song_database_maker_run_arbitrary
                              (GdamSongDatabaseMakerSkin* skin);


void  gdam_song_database_maker_kill_running
                              (GdamSongDatabaseMakerSkin* skin);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
